/*	controller.js

Another class name we could use here would be Router

*/

const
	UrlWrapper = require('url-wrapper').UrlWrapper,
	TestingTesting123 = require('./model/testing-testing-1-2-3').TestingTesting123,			
	statusCodes = require('http-status-codes'),
	log = console.log,
	htmlContentType = {'Content-Type': 'text/html'},
	jsonType = {'Content-Type': 'application/json'};

//=====================================	

class Controller {
	
	constructor(request, response) {
		this.url = UrlWrapper.fromRequest(request);
		this.request = request;
		this.response = response;
	}
	
	//-------------------------------------
	//public
	
	processRequest() {
		this.logRequestInfo();
		this.route();
	}
	
	route() {
		const path = this.url.path();
		if (path === '/testing123')
			this.testing123();	
		else
			log(`URL Path not handled: ${path}`);			
	}
	
	//-------------------------------------
	//private
	
	testing123() {
		const model = new TestingTesting123();
		this.serve(model.getResults());
	}	

	//-------------------------------------
	//serving data - private	
	
	serve(results) {
		//serve in JSON format
		const res = this.response;
		res.writeHead(statusCodes.OK, jsonType);		
		res.end(JSON.stringify(results));
	}		
	
	//-------------------------------------
	//helpers - private		
	
	logRequestInfo() {
		//dump request info to console
		log('received url: ' + this.request.url);	
		log('url path: ' + this.url.path());
		//stringify converts to user-friendly format
		log('url query: ' + JSON.stringify(this.url.query()));			
	}	
	
}
	
//=====================================	

exports.Controller = Controller;	
	
	
	
