/*
	main.js
	
	Minimal API provider
	
	This API simply returns the text "TESTING, TESTING 1-2-3"		
	
	This is a MINIMAL example for the sole purpose of
	verifying communications.

	Just fyi - some of what we minimize (eliminate):
	
		- query params not used
		- No real model here
		- No api key authentification
		
	This is a good place to start for a sanity communication check.
*/

const
	http = require('http'),
	Controller = require('./controller.js').Controller,
	port = process.env.PORT || 3000,
	startupCallback = () => console.log(`Server started on port: ${port}`);
	
const handleRequest	= (req, res) => {
	const controller = new Controller(req, res);
	controller.processRequest();
}

const server = http.createServer(handleRequest);
server.listen(port, startupCallback);	

